; Tetris89 0.77b macro file
; Last change on June 15, 2001 by Cyril CLEAUD <cyril.cleaud@gmail.com>

; this line was added for tests and cheat
cheatscore      equ  4500

; key ID for the GetKeyStat subprogramm
; this table is aimed to create compatibility between 89 and 92+
; value are now byte sized (space optimization)
KeyUp           equ  $81
KeyDown         equ  $82
KeyLeft         equ  $83
KeyRight        equ  $84
KeyESC          equ  $85
Key2nd          equ  $86
KeyShift        equ  $87
KeyDiamond      equ  $88
KeyAlpha        equ  $89
KeyHome         equ  $8A
KeyENTER        equ  $8B
KeyF1           equ  $8C
KeyF2           equ  $8D
KeyF3           equ  $8E

; 89 key map for GetKeyStat
;Up 	 Rotate piece (left) ...................... > #0,keystat
;2nd     Rotate piece (left)                        > #4,keystat
;Shift   Rotate piece (right) ..................... > #5,keystat
;Down	 Move the piece faster downwards            > #2,keystat
;Left	 Move the piece left ...................... > #1,keystat
;Right	 Move the piece right                       > #3,keystat
;Diamond Move the piece all the way down .......... > #6,keystat
;Alpha	 Pause  (not possible in two player mode)   > #7,keystat
;ESC	 Abort game ............................... > #0,keystat+6
;HOME    Teacher Key : turn off the calculator      > #6,keystat+5
;ENTER   Quit dialog box                            > #0,keystat+1
;F1      Cheat key 1 (in cheat version) ........... > #7,keystat+5
;F2      Cheat key 2 (in cheat version)             > #7,keystat+4
;F3      Cheat key 3 (in cheat version) ........... > #7,keystat+3

; 92+ key map for GetKeyStat (value marked by * are not sure)
;LEFT   Move piece left ........................... > #4,keystat
;RIGHT  Move piece right                            > #6,keystat
;DOWN   Move the piece faster downwards ........... > #7,keystat
;UP     Rotate clockwise (if not disabled)          > #5,keystat
;F1*    Rotate anti-clockwise ..................... > #4,keystat+7
;F5*    Rotate clockwise                            > #4,keystat+6
;HAND*  Drop ...................................... > #3,keystat
;D*     Drop                                        > #2,keystat+2
;T      Teacher key (not possible in 2P mode)       > #3,keystat+4
;P      Pause (not possible in 2P mode) ........... > #7,keystat+6
;Q*     Quit                                        > #6,keystat+8
;ESC*   Quit ...................................... > #3,keystat+9
;ENTER  Quit dialog box                             > #1,keystat+9
;ENTER2 Same (it's the enter below the keypad) .... > #6,keystat+6
;F2     Cheat key 1 (in cheat version)              > #4,keystat+4
;F3     Cheat key 2 (in cheat version) ............ > #4,keystat+2
;F4     Cheat key 3 (in cheat version)              > #4,keystat+9


; GetKey value_write,value_read
GetKey MACRO
 move.w  \1,($600018)
 movem.l d0,-(a7)       ; save d0
 moveq   #9,d0			; just 10 nops to let hardware react
\GetKeyWait
 nop
 dbra     d0,\GetKeyWait
 movem.l (a7)+,d0       ; restore d0
 move.b  ($60001B),\2
 ENDM

; WriteStr x,y,style,LPSTR
WriteStr MACRO
 move.w  \3,-(a7)
 pea     \4
 move.w  \2,-(a7)
 move.w  \1,-(a7)
 jsr     tios::DrawStrXY
 lea     10(a7),a7
 ENDM

; WriteStr x,y,style,LPSTR_with_address_reg
WriteStrA MACRO
 move.w  \3,-(a7)
 move.l  \4,-(a7)
 move.w  \2,-(a7)
 move.w  \1,-(a7)
 jsr     tios::DrawStrXY
 lea     10(a7),a7
 ENDM

; SetFont number_of_font
SetFont MACRO
 move.w  \1,-(a7)
 jsr     tios::FontSetSys
 lea     2(a7),a7
 ENDM